Attribute VB_Name = "MTestTree"
Option Explicit

Sub TestTree()
    Dim tree As NTree

    Set tree = GetFileSystemTree(True)

    DumpCounts tree
'    WalkTree tree
'    WalkLevel tree, 3

    tree.Dispose
End Sub
Sub WalkTree(ByVal tree As NTree)
    With tree.GetEnumerator
        Do While .MoveAll = True
            Debug.Print Spc(.Current.Level * 2); .Current.Value
        Loop
    End With
End Sub
Sub WalkLevel(ByVal tree As NTree, ByVal nLevel As Long)
    With tree.GetEnumerator
        Do While .MoveAtLevel(nLevel) = True
            Debug.Print .Current.Value
        Loop
    End With
End Sub
Sub DumpCounts(ByVal tree As NTree)
    Debug.Print "Total: " & tree.Count
    Debug.Print "Depth: " & tree.Depth
    Dim i As Long
    For i = 0 To tree.Depth
        Debug.Print "Count at level " & i & ": " & tree.GetCountAtLevel(i)
    Next i
End Sub


Function GetDummyTree() As NTree
    Set GetDummyTree = New NTree
    GetDummyTree.Create "Root"
    With GetDummyTree.Root.Children
        .Add "Eins"
        .Add "Zwei"
        With .Item(0).Children
            .Add "Uno"
            .Add "Dos"
            With .Item(1).Children
                .Add "111"
                .Add "222"
                .Add "333"
            End With
        End With
        With .Item(1).Children
            .Add "One"
            .Add "Two"
        End With
        .Add "Drei"
        .Add "Vier"
        With .Item(3).Children
            .Add "Odin"
            .Add "Dwa"
        End With
    End With
End Function
Function GetFileSystemTree(Optional ByVal fFiles As Boolean) As NTree
    Dim fso As FileSystemObject: Set fso = New FileSystemObject
    Dim fdr As Folder: Set fdr = fso.GetFolder("C:\")
    Set GetFileSystemTree = New NTree: GetFileSystemTree.Create fdr.Path
    ReadSubFolders fdr, GetFileSystemTree.Root, fFiles
End Function
Function ReadSubFolders(ByVal fdr As Folder, ByVal lnk As CLink, Optional ByVal fFiles As Boolean)
    Dim subfdr As Folder, subfile As File, sublnk As CLink
    For Each subfdr In fdr.SubFolders
        Set sublnk = lnk.Children.Add(subfdr.Name)
        ReadSubFolders subfdr, sublnk, fFiles
    Next subfdr
    If fFiles = True Then
        For Each subfile In fdr.Files
            Set sublnk = lnk.Children.Add(subfile.Name)
        Next subfile
    End If
End Function

  

