VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NTreeWalker"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Tree As NTree
Private m_Current As CLink


Public Sub Attach(ByVal tree As NTree)
    Set m_Tree = tree
End Sub
Public Sub Dispose()
    Set m_Tree = Nothing
    Set m_Current = Nothing
End Sub


Public Function MoveTop() As Boolean
    If m_Tree Is Nothing Then Err.Raise 5
    Set m_Current = m_Tree.Root
    MoveTop = Not (m_Current Is Nothing)
End Function
Public Function TryMoveUp() As Boolean
    If m_Tree Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then Err.Raise 5
    If Not m_Current.Parent Is Nothing Then
        Set m_Current = m_Current.Parent
        TryMoveUp = True
    End If
End Function
Public Function TryMoveDown() As Boolean
    If m_Tree Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then Err.Raise 5
    If m_Current.Children.Count > 0 Then
        Set m_Current = m_Current.Children.Item(m_Current.Children.LowerBound)
        TryMoveDown = True
    End If
End Function
Public Function TryMoveNext() As Boolean
    If m_Tree Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then Err.Raise 5
    If Not m_Current.NextLink Is Nothing Then
        Set m_Current = m_Current.NextLink
        TryMoveNext = True
    End If
End Function
Public Function TryMovePrevious() As Boolean
    If m_Tree Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then Err.Raise 5
    If Not m_Current.PrevLink Is Nothing Then
        Set m_Current = m_Current.PrevLink
        TryMovePrevious = True
    End If
End Function
Public Function MoveAll() As Boolean
    If m_Current Is Nothing Then
        MoveAll = Me.MoveTop
    ElseIf TryMoveDown = True Then
        MoveAll = True
    ElseIf TryMoveNext = True Then
        MoveAll = True
    ElseIf TryMoveUp = True Then
        Do Until TryMoveNext = True
            If TryMoveUp = False Then Exit Function
        Loop
        MoveAll = True
    End If
End Function
Public Function MoveAtLevel(ByVal nLevel As Long) As Boolean
    Do While MoveAll = True
        If m_Current.Level = nLevel Then
            MoveAtLevel = True
            Exit Do
        End If
    Loop
End Function


Public Property Get Current() As CLink
    Set Current = m_Current
End Property
Public Sub Reset()
    Set m_Current = Nothing
End Sub
Public Function Clone() As NTreeWalker
    Err.Raise 5, , "Not implemented"
End Function



